# https://docs.odriverobotics.com/v/0.5.4/getting-started.html
# https://docs.odriverobotics.com/v/0.5.4/encoders.html
# https://eu.odriverobotics.com/shop/cui-amt-102
# https://hobbyking.com/en_us/turnigy-sk8-6374-192kv-sensored-brushless-motor-14p.html
https://docs.odriverobotics.com/v/0.5.4/control.html # tune PID

# pos vinkel er med klokka

# position mode? default
odrv0.axis1.controller.config.control_mode = 3
odrv0.axis1.controller.config.enable_torque_mode_vel_limit = False

odrv0.vbus_voltage

############################################################# HELP
dump_errors(odrv0)
odrv0.clear_errors()
odrv0.reboot()
odrv0.axis0.controller.input_pos # lese av pos
odrv0.axis0.encoder.config.offset = 0 # i manuelt satt pos, resetter off
odrv0.axis0.requested_state = AXIS_STATE_IDLE
exec(open('r2.py').read())

############################################################# INI 0 liten motor 8192
odrv0.config.enable_brake_resistor = False
odrv0.axis0.motor.config.current_lim = 50 # Overordnet
odrv0.axis0.controller.config.vel_limit = 80 # Overordnet
odrv0.axis0.motor.config.torque_constant = 8.27/192 # 8.27 / 90 (8.27/KT)
odrv0.axis0.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis0.encoder.config.cpr = 8192
odrv0.axis0.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis0.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis0.motor.config.pole_pairs = 7 #20
odrv0.config.dc_max_negative_current = -5

odrv0.axis0.trap_traj.config.accel_limit = 60 # 45 # For trapes
odrv0.axis0.trap_traj.config.vel_limit = 65 # 35 # For trapes 
odrv0.axis0.trap_traj.config.decel_limit = 60 # 45 # For trapes
odrv0.axis0.controller.config.pos_gain = 40 # 180 # strammhet
odrv0.axis0.controller.config.vel_gain = 0.25 # turn/s
odrv0.axis0.controller.config.vel_integrator_gain = 0 # accelerasjon?
odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.save_configuration() # Ikke bry seg om feilmelding

############################################################# SETTE INDEX PULSE 0
odrv0.axis0.encoder.config.use_index = True
odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.axis0.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
odrv0.axis0.requested_state = AXIS_STATE_ENCODER_OFFSET_CALIBRATION
odrv0.axis0.error # 0
odrv0.axis0.encoder.config.phase_offset # et heltall
odrv0.axis0.encoder.config.direction # 1 eller -1
odrv0.axis0.encoder.config.pre_calibrated = True
odrv0.axis0.config.startup_encoder_index_search = False # hvis søk under startup, ellers kjøre AXIS_STATE_ENCODER_INDEX_SEARCH hver gang
odrv0.axis0.motor.config.pre_calibrated = True
odrv0.save_configuration() # Ikke bry seg om feilmelding

########### STARTUP 0

odrv0.axis0.requested_state = AXIS_STATE_ENCODER_INDEX_SEARCH
# odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE

odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.axis0.requested_state = AXIS_STATE_IDLE

#############################################################
#############################################################
#############################################################
odrv0.config.dc_max_negative_current = -10
dump_errors(odrv0)
odrv0.clear_errors()

odrv0.axis0.controller.config.vel_limit = 150
odrv0.axis0.trap_traj.config.accel_limit = 130 # 45 # For trapes
odrv0.axis0.trap_traj.config.vel_limit = 130 # 35 # For trapes 
odrv0.axis0.trap_traj.config.decel_limit = 130 # 45 # For trapes

strom = odrv0.axis0.motor.current_control.Iq_measured

odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE

offset = odrv0.axis0.encoder.pos_estimate

from datetime import datetime
import time
import math 

# sin kanal 1
dT = 8000 # samplings intervall us, 500Hz
f = 0.8   # Hz for sinus eksemplet 
u = 128/12

periodNoNow = 0
periodNoOld = 0 
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(200*10): # 20sec, 10000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    strom = odrv0.axis0.motor.current_control.Iq_measured
    if strom < -1:
        odrv0.axis0.controller.input_pos = odrv0.axis0.controller.input_pos + 0.001   
    if strom < -2:
        odrv0.axis0.controller.input_pos = odrv0.axis0.controller.input_pos + 0.002  
    if strom < -3:
        odrv0.axis0.controller.input_pos = odrv0.axis0.controller.input_pos + 0.003                          
    if strom > 1:
        odrv0.axis0.controller.input_pos = odrv0.axis0.controller.input_pos - 0.001
time.sleep(4)
odrv0.axis0.requested_state = AXIS_STATE_IDLE










